  
        
;        GP1 MAIN AUSGANG 
;        GP2 INTERRUPT AUSGANG 
;   ZUSAMMEN GESCHALTET WIE BEI DTMF-GEBER 
        
;        GP5 TASTER --> TON A ENABLE / AKTIV BEI LOW        
;        GP4 TASTER --> TON D ENABLE / AKTIV BEI LOW 
        
;*****************************************************************************
;*             SIRENE MIT 2 FREQUENZEN  (GP1+GP2)   TON A + D                *
;*                              30.08.20                                     *
;*****************************************************************************

        LIST    P=12F629       
        TITLE   "MARTINSHORN"

        ERRORLEVEL -302
        INCLUDE <P12F629.INC>

__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;4MHZ OSZILLATOR T=1:F / T=1:4MHZ / T=0,25SEC --> 1MAL NOP = 1,0SEC
        
;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


ABBRUCH                 EQU     0X22               ;ABBRUCH BEI BIT0 LOW
MERK1                   EQU     0X23               ;BEGINNT MIT HIGH HALBWELLE BEI GP2 ALS INTERRUPT
ZAE                     EQU     0X24               ;EINE HALBWELLE GP1(MAIN) 
                     
W_STACK                 EQU     0X25               ;FUER PUSH UND POP
S_STACK                 EQU     0X26               ;FUER PUSH UND POP


;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7
        
        
TONA_I      EQU D'221'  ;TONA INTERRUPT AN GP2 439HZ
TOND_I      EQU D'231'  ;TOND INTERRUPT AN GP2 614HZ
      
;BERECHNUNG TIMER0 FUER 450HZ
;T=1:FREQUENZ /// T=1:450HZ=2,22222MSEC /FUER EINE HALBWELLE :2= 1,1111MSEC
                        
;ZEITBERECHNUNG FUER 1,1111MSEC
;PRESCALER 32X  *  SYSTEM 4X  * TAKTZEIT ====> 32*4*0,25SEC=32SEC 
;1,1111MSEC : 32SEC=34,7   GENOMMEN GANZAHLIG 35                                      
;ALSO NACHRECHNUNG 
;
;TMR0 ALSO D'256'-D'35'=D'221' 
;221 DEZIMAL OBEN EINTRAGEN
                        
;BEI D'221' WAREN ES 439HZ         

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;BERECHNUNG TIMER0 FUER 587HZ
;T=1:FREQUENZ /// T=1:587HZ=1,7035MSEC /FUER EINE HALBWELLE :2= 0,85178MSEC
                        
;ZEITBERECHNUNG FUER 0,85178MSEC
;PRESCALER 32X  *  SYSTEM 4X  * TAKTZEIT ====> 32*4*0,25SEC=32SEC 
;0,85178MSEC : 32SEC= 26,61  GENOMMEN GANZAHLIG 27                                      
;ALSO NACHRECHNUNG 
;
;TMR0 ALSO D'256'-D'27'=D'229' 
;229 DEZIMAL OBEN EINTRAGEN
                                
;BEI D'231' WAREN ES 614HZ      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      
      
      
;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        MOVLW   B'11111001'                 ;GP1 + GP2 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL 

;INIT TIMER 0 
                MOVLW   B'10000100'             ;BIT0-2 1=PRESCALER1:32, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG  
                
;                        MOVLW   B'10000111'   ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, 
                                              ;BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
;                        MOVWF   OPTION_REG 
                                              
                        BANK0
 
;INIT TIMER 1 
                        MOVLW   B'00110000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [11]1:8 VORERST 0
                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
                        BSF     MERK1, BIT0 ;START BEI INTERRUPT MIT HIGH-HALBWELLE
                          
                        
                        
;INTERRUPT ZULASSEN             
                        BSF     INTCON, GIE     ;ALLGEMEINES INTERRUPT ENABLE
                        BSF     INTCON, PEIE 
                        BSF     INTCON, T0IE    ;OVERFLOW INTERRUPT BEI TIMER0 ZULASSEN/ENABLE
                         
                          
;TIMER0 START                        
;                        MOVLW D'70'
;                        MOVWF   TMR0            ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
;                        BCF     INTCON, T0IF    ;OVERFLOW
                     
ANFANG                        
        BSF     GPIO, GP1       ;TON
        
        BCF     ABBRUCH, BIT0
        
        BTFSS   GPIO, GP5
        CALL    ZS_TONA        
            
        BTFSS   GPIO, GP4
        CALL    ZS_TOND        
        
        BTFSS   ABBRUCH, BIT0
        GOTO    ANF01
        
        BCF     GPIO, GP1       ;TON
        
        BCF     ABBRUCH, BIT0
    
        BTFSS   GPIO, GP5
        CALL    ZS_TONA
         
        BTFSS   GPIO, GP4
        CALL    ZS_TOND        
                
        BTFSS   ABBRUCH, BIT0
        GOTO    ANF01
        
        GOTO    ANFANG

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,       
ANF01   BCF     GPIO, GP1       ;DAMIT KEIN STROM RAUSKOMMT

LL1     BCF     INTCON, GIE     ;INTERRUPT SPERREN 
        BTFSC   INTCON, GIE
        GOTO    LL1
        BCF     GPIO, GP2       ;DAMIT KEIN STROM RAUSKOMMT
         
;TIMER0 START
TA00    BTFSC   GPIO, GP5   ;TONA
        GOTO    TA01
        MOVLW   TONA_I
        GOTO    TA02
    
TA01    BTFSC   GPIO, GP4   ;TOND
        GOTO    TA00
        MOVLW   TOND_I
       
TA02    MOVWF   TMR0            ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
        BCF     INTCON, T0IF    ;OVERFLOW
   
        BSF     INTCON, GIE     ;INTERRUPT WIEDER EINSCHALTEN
     
        GOTO    ANFANG
        
;*****************************************************************************
;*                            INTERRUPT-PROGRAMM TON AN GP2                  *
;*****************************************************************************
INTERRUPT
        PUSH
        
        BTFSS   MERK1, BIT0
        GOTO    INT2
        
        BSF     GPIO, GP2
        BCF     MERK1, BIT0
        GOTO    INT1
        
INT2
        BCF     GPIO, GP2
        BSF     MERK1, BIT0
        
INT1    BTFSC   GPIO, GP5   ;TONA
        GOTO    ITA01
        MOVLW   TONA_I
        GOTO    ITA02
    
ITA01   BTFSC   GPIO, GP4   ;TOND
        GOTO    ITA00
        MOVLW   TOND_I
        
;TIMER0 START
ITA02   MOVWF   TMR0            ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
        BCF     INTCON, T0IF    ;OVERFLOW
 
ITA00   POP
        RETFIE
 
        
;*****************************************************************************
;*                            ZEITSCHLEIFE TON AN GP1                        *
;*****************************************************************************
ZS_TONA
        BSF     ABBRUCH, BIT0
        MOVLW   D'50' 
        MOVWF   ZAE
        
ZS_TON1A
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP ;10STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        ;NOP
        ;NOP ;20STCK. NOPS

        DECFSZ  ZAE, F
        GOTO    ZS_TON1A

        RETURN
        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ZU FREQUENZ:
;BERECHNUNG:
;T=1:F  /  T=1:450HZ=2,22222MSEC /FUER EINE HALBWELLE :2= 1,11111MSEC

;ZEITSCHLEIFE MIT NOP'S 435HZ BERECHNEN:
;1,1111MSEC : 1,0SEC = 1111 (NOP'S) 
;1111 (NOP'S) : 20(NOP'S) = 55,55MAL(DURCHLAEUFE) GENOMMEN 50

;BEI 20X NOP  ==  421HZ
 
;BEI 19X NOP  ==  440HZ  /// SCHWEBUNG SOLL ABER NICHT SEIN  

;BEI 18X NOP  ==  461HZ
        
;*****************************************************************************
;*                            ZEITSCHLEIFE TON AN GP1                        *
;*****************************************************************************
ZS_TOND
        BSF     ABBRUCH, BIT0 
        MOVLW   D'45' 
        MOVWF   ZAE
        
ZS_TON1D
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP ;10STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        ;NOP
        ;NOP
        ;NOP
        ;NOP
        ;NOP ;20STCK. NOPS

        DECFSZ  ZAE, F
        GOTO    ZS_TON1D

        RETURN
        
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ZU FREQUENZ:
;BERECHNUNG:
;T=1:F  /  T=1:587HZ=1,7035MSEC /FUER EINE HALBWELLE :2= 0,85178MSEC

;ZEITSCHLEIFE MIT NOP'S 240HZ BERECHNEN:
;0,85178MSEC : 1,0SEC = 851 (NOP'S) 
;851 (NOP'S) : 15(NOP'S) = 56,733MAL(DURCHLAEUFE) GENOMMEN 57

;BEI 15X NOP + D'57' ==  470HZ
 
;BEI 15X NOP + D'55' ==  490HZ  BEI -D'2' 20HZ  // BEI 100HZ -D'10' FOLGT D'45'
 
;BEI 15X NOP + D'45' ==  596HZ MUSS SO GEHEN 

;BEI 16X NOP + D'45' ==  565HZ
 
 
                        END
                        
                        
                        





