
;*****************************************************************************
;*                         STEUERUNG MARTINSHORN                             *
;*                              30.08.20                                     *
;*****************************************************************************

        LIST    P=12F675       
        TITLE   "MARTINSHORN-STEUERUNG"

        ERRORLEVEL -302
        INCLUDE <P12F675.INC>

__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;--------------------------------------------------------------------------


;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


MERK                    EQU     0X22
AD_H                    EQU     0X23
AD_L                    EQU     0X24


;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7



;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE              ; SOFORT INTERRUPT


    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON
                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;DIGITAL IO
                        MOVLW   B'11111001'                 ;GP0/AN0 ALS EINGANG (ALSO HIER DIE 1), GP1 UND GP2 ALS AUSGANG HIER DIE 0
                        MOVWF   TRISIO
                        BANK0
                        BSF     GPIO, GP1 ;TON-A  ;TON AUS
                        BSF     GPIO, GP2 ;TON-D
                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'00110001'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP1 + GP2 DIGITAL I/O     AN0 -ANALOG/DIGITAL WANDLER MIT RC-TAKT-INTERN  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL 

;INIT TIMER 0 
                        MOVLW   B'10000111'             ;BIT0-2 111=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG      
                        BANK0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'10000000' ;ADMF=0 RECHTSBNDIG, VDD ALS REF, CHANNEL AN0, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;INIT ENDE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        
ANFANG                        
                        BTFSC   GPIO, GP5   ;TASTER ABFRAGE
                        GOTO    STOP
                        
                        BCF     GPIO, GP1   ;TONA EIN
                        CALL    AD
                        CALL    ZS10MSEC_X1 ;ACHTEL NOTENLAENGE
                        BSF     GPIO, GP1   ;TONA AUS
                        BTFSC   GPIO, GP5   ;TASTER ABFRAGE
                        GOTO    STOP
                        
                        BCF     GPIO, GP2   ;TOND EIN
                        CALL    AD
                        CALL    ZS10MSEC_X2 ;VIERTEL NOTENLAENGE ALSO LAENGER ALS OBEN
                        BSF     GPIO, GP2   ;TONA AUS                        
                        BTFSC   GPIO, GP5   ;TASTER ABFRAGE
                        GOTO    STOP
                        

                        BCF     GPIO, GP1   ;TONA EIN
                        CALL    AD
                        CALL    ZS10MSEC_X1 ;ACHTEL NOTENLAENGE
                        BSF     GPIO, GP1   ;TONA AUS
                        BTFSC   GPIO, GP5   ;TASTER ABFRAGE
                        GOTO    STOP
                        
                        BCF     GPIO, GP2   ;TOND EIN
                        CALL    AD
                        CALL    ZS10MSEC_X2 ;VIERTEL NOTENLAENGE ALSO LAENGER ALS OBEN
                        BSF     GPIO, GP2   ;TONA AUS                        
                        BTFSC   GPIO, GP5   ;TASTER ABFRAGE
                        GOTO    STOP

                        BCF     GPIO, GP1   ;TONA EIN
                        CALL    AD
                        CALL    ZS10MSEC_X1 ;ACHTEL NOTENLAENGE
                        BSF     GPIO, GP1   ;TONA AUS
                        BTFSC   GPIO, GP5   ;TASTER ABFRAGE
                        GOTO    STOP
                        
                        BCF     GPIO, GP2   ;TOND EIN
                        CALL    AD
                        CALL    ZS10MSEC_X2 ;VIERTEL NOTENLAENGE ALSO LAENGER ALS OBEN
                        BSF     GPIO, GP2   ;TONA AUS                        
                        BTFSC   GPIO, GP5   ;TASTER ABFRAGE
                        GOTO    STOP
                        
                        
                        CALL    AD          ;PAUSE KEIN TON
                        CALL    ZS10MSEC_X2 ;VIERTEL NOTENLAENGE ALSO LAENGER ALS OBEN
                        BTFSC   GPIO, GP5   ;TASTER ABFRAGE
                        GOTO    STOP
                        GOTO    ANFANG
                        
                        
                        
                        
STOP                    BTFSS   GPIO, GP5
                        GOTO    ANFANG
                        BSF     GPIO, GP1   ;KEIN TON / ALLE BEIDE AUS
                        BSF     GPIO, GP2
                        GOTO    STOP
                        

;*****************************************************************************
;*         UNTERPROGRAMM AD-WANDLUNG                                         *
;*****************************************************************************
AD           
                BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                CALL    ZS40MUE             ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                CALL    ZS40MUE             ;ZEITSCHLEIFE

III             BTFSS  PIR1, ADIF
                GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    

;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                MOVF    ADRESH, W
                MOVWF   AD_H

                BANK1
                MOVF    ADRESL, W
                BANK0
                MOVWF   AD_L
                
                RRF     AD_H, F
                RRF     AD_L, F
                BCF     STATUS, C   ;512 BIT MAX.
               
                RRF     AD_H, F
                RRF     AD_L, F     
                BCF     STATUS, C   ;256 BIT MAX. / NUR NOCH 1BYTE
                
                RRF     AD_L, F
                BCF     STATUS, C   ;128 BIT MAX.
                    
                RRF     AD_L, F
                BCF     STATUS, C   ;64 BIT MAX.
                      
                RRF     AD_L, F
                BCF     STATUS, C   ;32 BIT MAX.
                 
                CALL    ZS10MSEC_24   ;KORREKTUR DAMIT ES BEI D'1'-AD_L NICHT ZU SCHNELL IST
                
                MOVLW    0X00
                SUBWF    AD_L, W
                BTFSS    STATUS, Z
                RETURN

                INCF     AD_L, F      ;UM EINS ERHHEN ALSO 0X01 FR AD_L
                RETURN
                
                                  
;*****************************************************************************
;*         UNTERPROGRAMM MIT TIMER0 ALS ZEITSCHLEIFE FUER  10MSEC ....       *
;*****************************************************************************
ZS10MSEC_24
                        MOVLW   D'24'
                        MOVWF   MERK
                        
T01_                    MOVLW   D'217'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 217 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
T02_                    BTFSS   INTCON, T0IF           
                        GOTO    T02_                     
                        
                        DECFSZ  MERK, F                
                        GOTO    T01_                    

                RETURN
                
;ZEITBERECHNUNG FUER 10MS
;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.25S=256S   /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;10MS : 256S= 39                                                    /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;256S*D'39'=10MS
;TMR0 ALSO D'256'-D'39'=D'217' ENTSPRICHT CA. 10MS
;217 DEZIMAL OBEN EINTRAGEN
                
;*****************************************************************************
;*         UNTERPROGRAMM MIT TIMER0 ALS ZEITSCHLEIFE FUER  10MSEC .... *1    *
;*****************************************************************************
ZS10MSEC_X1
                        MOVF    AD_L, W
                        MOVWF   MERK
                        
T01                     MOVLW   D'217'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 217 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
T02                     BTFSS   INTCON, T0IF           
                        GOTO    T02                     
                        
                        DECFSZ  MERK, F                
                        GOTO    T01                    

                RETURN

;*****************************************************************************
;*         UNTERPROGRAMM MIT TIMER0 ALS ZEITSCHLEIFE FUER  10MSEC .... *2    *
;*****************************************************************************
ZS10MSEC_X2
                        MOVF    AD_L, W
                        MOVWF   MERK
                        
TT01                    MOVLW   D'217'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 217 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
TT02                    BTFSS   INTCON, T0IF           
                        GOTO    TT02                     
                        
                        DECFSZ  MERK, F                
                        GOTO    TT01
                        
;DAS 2-TE MAL                        
                        MOVF    AD_L, W
                        MOVWF   MERK
                        
TTT01                   MOVLW   D'217'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 217 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
TTT02                   BTFSS   INTCON, T0IF           
                        GOTO    TTT02                     
                        
                        DECFSZ  MERK, F                
                        GOTO    TTT01  

                        RETURN
            
;*****************************************************************************
;*                              CA. 40SEC ZEITSCHLEIFE                      *
;*****************************************************************************

ZS40MUE     MOVLW   D'4'
            MOVWF   MERK
MSA         NOP             
            NOP         
            NOP
            NOP
            NOP
            NOP
            NOP
            DECFSZ  MERK, F
            GOTO    MSA
            RETURN








                            END
                            
                            
                            